import java.util.*;

class Fruit {}
class Banana extends Fruit {}
class Orange extends Fruit {}

public class Sample {
  public static <T> void copy(List<T> from, List<? super T> to) {
    System.out.println("copying...");
    for(var e: from) {
      to.add(e);
    }
  }

  public static void main(String[] args) {
    Banana banana = new Banana();
    Orange orange = new Orange();

    List<Fruit> fruits = new ArrayList<>();
    List<Banana> bananas = new ArrayList<>();
    List<Orange> oranges = new ArrayList<>();

    copy(fruits, new ArrayList<Fruit>());
    //copy(fruits, bananas); //Should not be allowed, banans should not have some other type of fruits

    copy(bananas, fruits); //Should be allowed, fruits can have a banana
    //? super T says the type can beany super type of the parameteric
    //type used in the first argument.
  }
}

